angular.module('beamng.apps')
.directive('busDispctrl', ['$sce', function ($sce) {
  return {
    templateUrl:  '/ui/modules/apps/BusDispCtrl/app.html',
    replace: true,
    restrict: 'EA',
    require: '^bngApp',
    link: function ($scope, element, attrs, ctrl) {
 
      const settingspath = '/settings/BusDispCtrl/settings.json';
      $scope.lastsettingspath = '/settings/BusDispCtrl/lastsettings.json';
      const minipath = '/settings/BusDispCtrl/minimize.json';
      const verpath = '/ui/modules/apps/BusDispCtrl/app.json';
		var newSettings = [{
			saveno: "1",
			savedest: "Destinaton 1",
			savecolour: "#B40404"
		},{
			saveno: "2",
			savedest: "Destinaton 2",
			savecolour: "#B43104"
		},{
			saveno: "3",
			savedest: "Destinaton 3",
			savecolour: "#B45F04"
		},{
			saveno: "4",
			savedest: "Destinaton 4",
			savecolour: "#B18904"
		},{
			saveno: "5",
			savedest: "Destinaton 5",
			savecolour: "#AEB404"
		},{
			saveno: "6",
			savedest: "Destinaton 6",
			savecolour: "#86B404"
		},{
			saveno: "7",
			savedest: "Destinaton 7",
			savecolour: "#5FB404"
		},{
			saveno: "8",
			savedest: "Destinaton 8",
			savecolour: "#31B404"
		},{
			saveno: "9",
			savedest: "Destinaton 9",
			savecolour: "#04B404"
		},{
			saveno: "10",
			savedest: "Destinaton 10",
			savecolour: "#04B431"
		},{
			saveno: "11",
			savedest: "Destinaton 11",
			savecolour: "#04B45F"
		},{
			saveno: "12",
			savedest: "Destinaton 12",
			savecolour: "#04B486"
		},{
			saveno: "13",
			savedest: "Destinaton 13",
			savecolour: "#04B4AE"
		},{
			saveno: "14",
			savedest: "Destinaton 14",
			savecolour: "#0489B1"
		},{
			saveno: "15",
			savedest: "Destinaton 15",
			savecolour: "#045FB4"
		},{
			saveno: "16",
			savedest: "Destinaton 16",
			savecolour: "#0431B4"
		},{
			saveno: "17",
			savedest: "Destinaton 17",
			savecolour: "#0404B4"
		},{
			saveno: "18",
			savedest: "Destinaton 18",
			savecolour: "#3104B4"
		},{
			saveno: "19",
			savedest: "Destinaton 19",
			savecolour: "#5F04B4"
		},{
			saveno: "20",
			savedest: "Destinaton 20",
			savecolour: "#8904B1"
		}];
		
		var newlastSettings = {
			setrouteno: "",
			setdest: "",
			setroutecol: "#000000"
		};
		$scope.setdisp = newlastSettings;
		
		$scope.imgformats = [{
			formatid: 1,
			format: ".png"
		},{
			formatid: 2,
			format: ".jpg"
		},{
			formatid: 3,
			format: ".bmp"
		},{
			formatid: 4,
			format: ".webp"
		},{
			formatid: 5,
			format: ".gif"
		}];
		
      ctrl.updateSettings = function (settings) {
		$scope.saveid = [];
		$scope.rowcolour = [];
		for (i = 0; i < settings.length; i++) {
			$scope.saveid.push(i);
			if (i % 2 == 1) {
				$scope.rowcolour.push("rgba(0,0,0,0.6)");
			} else {
				$scope.rowcolour.push("rgba(0,0,0,0.4)");
			}
		};
	  };
      ctrl.getSettings = function (settings) {
        bngApi.engineLua('jsonReadFile(' + bngApi.serializeToLua(settingspath) + ')', (settings) => {
		if (settings == null) {$scope.appSettings = newSettings; ctrl.updateSettings($scope.appSettings); return;} else {$scope.appSettings = [];}
		for (let i = 0; i < settings.length; i++) {
			$scope.appSettings.push({
			  saveno: settings[i].saveno,
			  savedest: settings[i].savedest,
			  savecolour: settings[i].savecolour,
			  saveextra1: settings[i].saveextra1,
			  saveextra2: settings[i].saveextra2,
			  saveextra1r: settings[i].saveextra1r,
			  saveextra2r: settings[i].saveextra2r,
			  saveint: settings[i].saveint,
			  savedestimg: settings[i].savedestimg,
			  saveextra1img: settings[i].saveextra1img,
			  saveextra2img: settings[i].saveextra2img,
			  saverouteimg: settings[i].saverouteimg,
			  savetxtcolour: settings[i].savetxtcolour,
			});
		}
		ctrl.updateSettings(settings);
		});
      };
      ctrl.getlastSettings = function (lastsettings) {
        bngApi.engineLua('jsonReadFile(' + bngApi.serializeToLua($scope.lastsettingspath) + ')', (lastsettings) => {
			if (lastsettings == null) {return;}
			  $scope.setdisp.setrouteno = lastsettings.setrouteno;
			  $scope.setdisp.setdest = lastsettings.setdest;
			  $scope.setdisp.setroutecol = lastsettings.setroutecol;
			  $scope.setdisp.setextra1 = lastsettings.setextra1;
			  $scope.setdisp.setextra2 = lastsettings.setextra2;
			  $scope.setdisp.setextra1r = lastsettings.setextra1r;
			  $scope.setdisp.setextra2r = lastsettings.setextra2r;
			  $scope.setdisp.setint = lastsettings.setint;
			  $scope.setdisp.setdestimg = lastsettings.setdestimg;
			  $scope.setdisp.setextra1img = lastsettings.setextra1img;
			  $scope.setdisp.setextra2img = lastsettings.setextra2img;
			  $scope.setdisp.setrouteimg = lastsettings.setrouteimg;
			  $scope.setdisp.settxtcolour = lastsettings.settxtcolour;
		});
      };

      ctrl.saveSettings = function (settings) {
		ctrl.updateSettings(settings);
        bngApi.engineLua('jsonWriteFile(' + bngApi.serializeToLua(settingspath) + ', ' + bngApi.serializeToLua(settings) + ', ' + bngApi.serializeToLua(true) + ')');
      };
	  
		  $scope.toggleAll = function(vis) {
			if (vis === undefined) {$scope.visible = !$scope.visible;} else {$scope.visible = vis;}
			if($scope.visible == false) {
			  $scope.appStyle = {appWidth: '170px', appHeight: '16px', appShow: 'hidden', miniWidth: '170px'};
			  $scope.cornerChar = '[Expand] Bus Display Controller';
			} else {
			  $scope.appStyle = {appWidth: '100%', appHeight: '100%', appShow: 'visible', miniWidth: '56px'};
			  $scope.cornerChar = '[Minimize]';
			}
			ctrl.savemini(!$scope.visible);
		  };

      ctrl.savemini = function (mini) {
		var savemn = {minimize: mini};
        bngApi.engineLua('jsonWriteFile(' + bngApi.serializeToLua(minipath) + ', ' + bngApi.serializeToLua(savemn) + ', ' + bngApi.serializeToLua(true) + ')');
      };
		  
      ctrl.getmini = function (mini) {
        bngApi.engineLua('jsonReadFile(' + bngApi.serializeToLua(minipath) + ')', (mini) => {
			if (mini == null) {return;}
			if(mini.minimize == true) {
				$scope.toggleAll(false);
			}
			if(mini[0] !== undefined && mini[0].minimize == true) {
				$scope.toggleAll(false);
			}
		});
      };
	  
      element.ready(function () {
		  var appjson = null;
			bngApi.engineLua('jsonReadFile(' + bngApi.serializeToLua(verpath) + ')', (appjson) => {
				if (appjson != null) {$scope.appversion = appjson.version;}
			});
		  var loadsettings = null;
		  var loadlastsettings = null;
		  var loadmini = null;
        ctrl.getSettings(loadsettings);
            if(loadsettings != null) {$scope.appSettings = loadsettings};
        ctrl.getlastSettings(loadlastsettings);
            if(loadlastsettings != null) {$scope.setdisp = loadlastsettings};
        ctrl.getmini(loadmini);
            if(loadmini != null) {$scope.toggleAll(!loadmini);};
      });
	  
		  function componentToHex(c) {
			var hex = c.toString(16);
			return hex.length == 1 ? "0" + hex : hex;
			}

			function rgbToHex(r, g, b) {
			return "#" + componentToHex(r) + componentToHex(g) + componentToHex(b);
			}
			
		  $scope.savesetting = function () {
			  $scope.appSettings[$scope.selectedId].saveno = $scope.cusrouteno;
			  $scope.appSettings[$scope.selectedId].savedest = $scope.cusdest;
			  $scope.appSettings[$scope.selectedId].savecolour = rgbToHex($scope.cuscolor.red, $scope.cuscolor.green, $scope.cuscolor.blue);
			  $scope.appSettings[$scope.selectedId].saveextra1 = $scope.cusextra1;
			  $scope.appSettings[$scope.selectedId].saveextra2 = $scope.cusextra2;
			  $scope.appSettings[$scope.selectedId].saveextra1r = $scope.cusextra1r;
			  $scope.appSettings[$scope.selectedId].saveextra2r = $scope.cusextra2r;
			  $scope.appSettings[$scope.selectedId].saveint = $scope.cusinterval;
			  $scope.appSettings[$scope.selectedId].savedestimg = $scope.cusdestimg;
			  $scope.appSettings[$scope.selectedId].saveextra1img = $scope.cusextra1img;
			  $scope.appSettings[$scope.selectedId].saveextra2img = $scope.cusextra2img;
			  $scope.appSettings[$scope.selectedId].saverouteimg = $scope.cusrouteimg;
			  $scope.appSettings[$scope.selectedId].savetxtcolour = [];
				for (let i = 0; i < 6; i++) {
					$scope.appSettings[$scope.selectedId].savetxtcolour[i] = rgbToHex($scope.custxtcolour[i].red, $scope.custxtcolour[i].green, $scope.custxtcolour[i].blue);
				}
			ctrl.saveSettings($scope.appSettings);
		  };
		  $scope.delsetting = function () {
			$scope.appSettings.splice($scope.selectedId, 1);
			if ($scope.selectedId >= $scope.appSettings.length && $scope.selectedId > 0) {$scope.selectedId--;}
			ctrl.saveSettings($scope.appSettings);
			$scope.delconfirm = false;
			$scope.selecteditemhighlight($scope.selectedId);
		  };
		  $scope.savenewsetting = function () {
			$scope.appSettings.push({
			  saveno: $scope.cusrouteno,
			  savedest: $scope.cusdest,
			  savecolour: rgbToHex($scope.cuscolor.red, $scope.cuscolor.green, $scope.cuscolor.blue),
			  saveextra1: $scope.cusextra1,
			  saveextra2: $scope.cusextra2,
			  saveextra1r: $scope.cusextra1r,
			  saveextra2r: $scope.cusextra2r,
			  saveint: $scope.cusinterval,
			  savedestimg: $scope.cusdestimg,
			  saveextra1img: $scope.cusextra1img,
			  saveextra2img: $scope.cusextra2img,
			  saverouteimg: $scope.cusrouteimg,
			  savetxtcolour: [rgbToHex($scope.custxtcolour[0].red, $scope.custxtcolour[0].green, $scope.custxtcolour[0].blue),
									rgbToHex($scope.custxtcolour[1].red, $scope.custxtcolour[1].green, $scope.custxtcolour[1].blue),
									rgbToHex($scope.custxtcolour[2].red, $scope.custxtcolour[2].green, $scope.custxtcolour[2].blue),
									rgbToHex($scope.custxtcolour[3].red, $scope.custxtcolour[3].green, $scope.custxtcolour[3].blue),
									rgbToHex($scope.custxtcolour[4].red, $scope.custxtcolour[4].green, $scope.custxtcolour[4].blue),
									rgbToHex($scope.custxtcolour[5].red, $scope.custxtcolour[5].green, $scope.custxtcolour[5].blue)],
			});
			if ($scope.appSettings.length == 1) {$scope.selectedId = "0";}
			ctrl.saveSettings($scope.appSettings);
		  };
		  $scope.selecteditemscroll = function () {
			  let selecteditem = document.getElementById('saveitem' + $scope.selectedId);
			  selecteditem.scrollIntoView({behavior: "smooth", block: "center", inline: "start"});
		  };
		  $scope.selecteditemhighlight = function (id) {
			  if ($scope.overwriteconfirm || $scope.delconfirm) {return;}
			  $scope.selectedId = id;
		  }
    },
    controller: function ($scope, $element, $attrs) {
		$scope.appStyle = {appWidth: '100%', appHeight: '100%', appShow: 'visible', miniWidth: '56px'};
		$scope.visible = true;
		$scope.disabled = true;
		$scope.overwriteconfirm = false;
		$scope.delconfirm = false;
		$scope.cornerChar = '[Minimize]';
		$scope.cusrouteno = ""
		$scope.cusdest = ""
		$scope.cusextra1 = ""
		$scope.cusextra2 = ""
		$scope.cusextra1r = ""
		$scope.cusextra2r = ""
		$scope.cusinterval = 3
		$scope.cusdestimg = 0
		$scope.cusextra1img = 0
		$scope.cusextra2img = 0
		$scope.cusrouteimg = 0
		$scope.cusdestimglistvis = 0
		$scope.cusextra1imglistvis = 0
		$scope.cusextra2imglistvis = 0
		$scope.cusrouteimglistvis = 0
		$scope.txtcolvis = false
		$scope.txtcolvisn = 0
		$scope.selectedId = "0"
		$scope.selectedicon = ""
		$scope.imgtooltip = "Click here to open the image folder and place the image to be displayed in the folder. Signs type marked with (BusDispCtrl) is required for Wentward buses to display images."
		$scope.imglisttooltip = "Open the image file list"
		$scope.imglistclosetooltip = "Close the image file list"
		$scope.imglistrefreshtooltip = "Refresh the image file list"
		$scope.txtcoltooltip = "Text colour"
		$scope.imglist = []
		  this.randomcolour = function() {
			$scope.cuscolor = {
			  red: Math.floor(Math.random() * 255),
			  green: Math.floor(Math.random() * 255),
			  blue: Math.floor(Math.random() * 255)
			};
		  };
		  this.randomcolour();
		  this.setcolour = function(r,g,b) {
			$scope.cuscolor = {
			  red: r,
			  green: g,
			  blue: b
			};
		  };
		$scope.custxtcolour = []
		var defaulttxtcolour = []
		var defaulttxtcolourhex = []
		for (let i = 0; i < 6; i++) {
			$scope.custxtcolour.push({
			  red: 255,
			  green: 255,
			  blue: 255
			});
			defaulttxtcolour.push({
			  red: 255,
			  green: 255,
			  blue: 255
			});
			defaulttxtcolourhex.push("#FFFFFF");
		}
		  this.settxtcolour = function(i,r,g,b) {
			$scope.custxtcolour[i] = {
			  red: r,
			  green: g,
			  blue: b
			};
		  };
		  this.randomtxtcolour = function(i) {
			$scope.custxtcolour[i] = {
			  red: Math.floor(Math.random() * 255),
			  green: Math.floor(Math.random() * 255),
			  blue: Math.floor(Math.random() * 255)
			};
		  };
		var txtcolourpicker = []
		for (let i = 0; i < 6; i++) {
			txtcolourpicker[i] = document.getElementById("txtcolourpicker" + i.toString());
		}
		let node1 = txtcolourpicker[0].firstElementChild;
		let node2 = txtcolourpicker[0].lastElementChild;
		  this.toggletxtcolvis = function(i) {
			  if ($scope.txtcolvisn == i) {$scope.txtcolvis = !$scope.txtcolvis;} else {$scope.txtcolvis = true;}
			  $scope.txtcolvisn = i;
			txtcolourpicker[i].appendChild(node1);
			txtcolourpicker[i].appendChild(node2);
		  };
		  this.savelastSettings = function (lastsettings) {
			bngApi.engineLua('jsonWriteFile(' + bngApi.serializeToLua($scope.lastsettingspath) + ', ' + bngApi.serializeToLua(lastsettings) + ', ' + bngApi.serializeToLua(true) + ')');
		  };
		  this.setingameroute = function() {
			var cmd = `controller.onGameplayEvent("bus_onRouteChange", {direction="`+$scope.setdisp.setdest+`", routeID="`+$scope.setdisp.setrouteno+`", routeColor="`+$scope.setdisp.setroutecol+`", displaytext="`+$scope.setdisp.setdest+`", displaytextrear="`+$scope.setdisp.setrouteno+`", extratext1="`+$scope.setdisp.setextra1+`", extratext2="`+$scope.setdisp.setextra2+`", interval="`+$scope.setdisp.setint+`", extratext1r="`+$scope.setdisp.setextra1r+`", extratext2r="`+$scope.setdisp.setextra2r+`", displayimg="`+$scope.setdisp.setdestimg+`", destimg="`+$scope.setdisp.setdestimg+`", extratext1img="`+$scope.setdisp.setextra1img+`", extratext2img="`+$scope.setdisp.setextra2img+`", routeimg="`+$scope.setdisp.setrouteimg+`", textcolour="`+$scope.setdisp.settxtcolour+`", displaytextcolour="`+$scope.setdisp.settxtcolour[1]+`", displaytextcolourrear="`+$scope.setdisp.settxtcolour[0]+`"})`;
			bngApi.activeObjectLua(cmd);
			this.savelastSettings($scope.setdisp);
		  };
		  this.setroute = function(routeno,dest,colour,extra1 = "",extra2 = "",intv = 3,extra1r = "",extra2r = "",destimg = 0,extra1img = 0,extra2img = 0,routeimg = 0,textcolour = defaulttxtcolourhex) {
			$scope.setdisp.setrouteno = routeno;
			$scope.setdisp.setdest = dest;
			$scope.setdisp.setroutecol = colour;
			$scope.setdisp.setextra1 = extra1;
			$scope.setdisp.setextra2 = extra2;
			$scope.setdisp.setextra1r = extra1r;
			$scope.setdisp.setextra2r = extra2r;
			$scope.setdisp.setint = intv;
			$scope.setdisp.setdestimg = destimg;
			$scope.setdisp.setextra1img = extra1img;
			$scope.setdisp.setextra2img = extra2img;
			$scope.setdisp.setrouteimg = routeimg;
			$scope.setdisp.settxtcolour = textcolour;
			this.setingameroute();
		  };
		  function componentToHex(c) {
			var hex = c.toString(16);
			return hex.length == 1 ? "0" + hex : hex;
			}

			function rgbToHex(r, g, b) {
			return "#" + componentToHex(r) + componentToHex(g) + componentToHex(b);
			}
		  this.setcusdisp = function() {
			$scope.setdisp.setrouteno = $scope.cusrouteno;
			$scope.setdisp.setdest = $scope.cusdest;
			$scope.setdisp.setroutecol = rgbToHex($scope.cuscolor.red, $scope.cuscolor.green, $scope.cuscolor.blue);
			$scope.setdisp.setextra1 = $scope.cusextra1;
			$scope.setdisp.setextra2 = $scope.cusextra2;
			$scope.setdisp.setextra1r = $scope.cusextra1r;
			$scope.setdisp.setextra2r = $scope.cusextra2r;
			$scope.setdisp.setint = $scope.cusinterval;
			if ($scope.cusdestimg != 0) {this.cusimg("cus_destimg",$scope.cusdestimgformat);}
			if ($scope.cusextra1img != 0) {this.cusimg("cus_extra1img",$scope.cusextra1imgformat);}
			if ($scope.cusextra2img != 0) {this.cusimg("cus_extra2img",$scope.cusextra2imgformat);}
			if ($scope.cusrouteimg != 0) {this.cusimg("cus_routeimg",$scope.cusrouteimgformat);}
			$scope.setdisp.setdestimg = $scope.cusdestimg;
			$scope.setdisp.setextra1img = $scope.cusextra1img;
			$scope.setdisp.setextra2img = $scope.cusextra2img;
			$scope.setdisp.setrouteimg = $scope.cusrouteimg;
			$scope.setdisp.settxtcolour = [];
			for (let i = 0; i < 6; i++) {
				$scope.setdisp.settxtcolour[i] = rgbToHex($scope.custxtcolour[i].red, $scope.custxtcolour[i].green, $scope.custxtcolour[i].blue);
			}
			this.setingameroute();
		  };
		  function hexToRgb(hex) {
			var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
			return result ? {
				r: parseInt(result[1], 16),
				g: parseInt(result[2], 16),
				b: parseInt(result[3], 16)
			} : null;
			}
		  this.cusimg = function(item,val) {
			  var newval = val;
			  document.getElementById(item + '0').style.background = "transparent";
			  document.getElementById(item + '1').style.background = "transparent";
			  if (val >= 1) {newval = 1;}
			  document.getElementById(item + newval.toString()).style.background = "#FF6600";
			  if (item == "cus_destimg") {
				if (val >= 1) {$scope.cusdestimgformat = val;}
				$scope.cusdestimg = val;
				this.refreshimglist(2);
			  } else if (item == "cus_extra1img") {
				if (val >= 1) {$scope.cusextra1imgformat = val;}
				$scope.cusextra1img = val;
				this.refreshimglist(3);
			  } else if (item == "cus_extra2img") {
				if (val >= 1) {$scope.cusextra2imgformat = val;}
				$scope.cusextra2img = val;
				this.refreshimglist(4);
			  } else if (item == "cus_routeimg") {
				if (val >= 1) {$scope.cusrouteimgformat = val;}
				$scope.cusrouteimg = val;
				this.refreshimglist(1);
			  }
		  };
		  this.loadcusdisp = function() {
			$scope.cusrouteno = $scope.setdisp.setrouteno;
			$scope.cusdest = $scope.setdisp.setdest;
			$scope.cuscolor = {
			  red: hexToRgb($scope.setdisp.setroutecol).r,
			  green: hexToRgb($scope.setdisp.setroutecol).g,
			  blue: hexToRgb($scope.setdisp.setroutecol).b
			};
			$scope.cusextra1 = $scope.setdisp.setextra1 == null ? "" : $scope.setdisp.setextra1;
			$scope.cusextra2 = $scope.setdisp.setextra2 == null ? "" : $scope.setdisp.setextra2;
			$scope.cusextra1r = $scope.setdisp.setextra1r == null ? "" : $scope.setdisp.setextra1r;
			$scope.cusextra2r = $scope.setdisp.setextra2r == null ? "" : $scope.setdisp.setextra2r;
			$scope.cusinterval = $scope.setdisp.setint == null ? 3 : $scope.setdisp.setint;
			$scope.cusdestimg = $scope.setdisp.setdestimg == null ? 0 : $scope.setdisp.setdestimg;
			$scope.cusextra1img = $scope.setdisp.setextra1img == null ? 0 : $scope.setdisp.setextra1img;
			$scope.cusextra2img = $scope.setdisp.setextra2img == null ? 0 : $scope.setdisp.setextra2img;
			$scope.cusrouteimg = $scope.setdisp.setrouteimg == null ? 0 : $scope.setdisp.setrouteimg;
			this.cusimg("cus_destimg",$scope.cusdestimg);
			this.cusimg("cus_extra1img",$scope.cusextra1img);
			this.cusimg("cus_extra2img",$scope.cusextra2img);
			this.cusimg("cus_routeimg",$scope.cusrouteimg);
			$scope.custxtcolour = $scope.setdisp.settxtcolour == null ? defaulttxtcolourhex : $scope.setdisp.settxtcolour;
			var temp = []
			for (let i = 0; i < 6; i++) {
				temp.push({
				red: hexToRgb($scope.custxtcolour[i]).r,
				green: hexToRgb($scope.custxtcolour[i]).g,
				blue: hexToRgb($scope.custxtcolour[i]).b
				});
			}
			$scope.custxtcolour = temp;
		  };
		  this.loadsetting = function () {
			  $scope.cusrouteno = $scope.appSettings[$scope.selectedId].saveno;
			  $scope.cusdest = $scope.appSettings[$scope.selectedId].savedest;
				$scope.cuscolor = {
				  red: hexToRgb($scope.appSettings[$scope.selectedId].savecolour).r,
				  green: hexToRgb($scope.appSettings[$scope.selectedId].savecolour).g,
				  blue: hexToRgb($scope.appSettings[$scope.selectedId].savecolour).b
				};
				$scope.cusextra1 = $scope.appSettings[$scope.selectedId].saveextra1 == null ? "" : $scope.appSettings[$scope.selectedId].saveextra1;
				$scope.cusextra2 = $scope.appSettings[$scope.selectedId].saveextra2 == null ? "" : $scope.appSettings[$scope.selectedId].saveextra2;
				$scope.cusextra1r = $scope.appSettings[$scope.selectedId].saveextra1r == null ? "" : $scope.appSettings[$scope.selectedId].saveextra1r;
				$scope.cusextra2r = $scope.appSettings[$scope.selectedId].saveextra2r == null ? "" : $scope.appSettings[$scope.selectedId].saveextra2r;
				$scope.cusinterval = $scope.appSettings[$scope.selectedId].saveint == null ? 3 : $scope.appSettings[$scope.selectedId].saveint;
				$scope.cusdestimg = $scope.appSettings[$scope.selectedId].savedestimg == null ? 0 : $scope.appSettings[$scope.selectedId].savedestimg;
				$scope.cusextra1img = $scope.appSettings[$scope.selectedId].saveextra1img == null ? 0 : $scope.appSettings[$scope.selectedId].saveextra1img;
				$scope.cusextra2img = $scope.appSettings[$scope.selectedId].saveextra2img == null ? 0 : $scope.appSettings[$scope.selectedId].saveextra2img;
				$scope.cusrouteimg = $scope.appSettings[$scope.selectedId].saverouteimg == null ? 0 : $scope.appSettings[$scope.selectedId].saverouteimg;
				this.cusimg("cus_destimg",$scope.cusdestimg);
				this.cusimg("cus_extra1img",$scope.cusextra1img);
				this.cusimg("cus_extra2img",$scope.cusextra2img);
				this.cusimg("cus_routeimg",$scope.cusrouteimg);
				$scope.custxtcolour = $scope.appSettings[$scope.selectedId].savetxtcolour == null ? defaulttxtcolourhex : $scope.appSettings[$scope.selectedId].savetxtcolour
				var temp = []
				for (let i = 0; i < 6; i++) {
					temp.push({
					red: hexToRgb($scope.custxtcolour[i]).r,
					green: hexToRgb($scope.custxtcolour[i]).g,
					blue: hexToRgb($scope.custxtcolour[i]).b
					});
				}
				$scope.custxtcolour = temp;
				this.setcusdisp();
		  };
		  this.selecticon = function(icon,iconbtn) {
			  if ($scope.selectedicon == icon) {
			  $scope.selectedicon = "";
			  document.getElementById(iconbtn).style.border = "0px solid";
			  } else {
			  $scope.selectedicon = icon;
			  document.getElementById('icon_bng').style.border = "0px solid";
			  document.getElementById('icon_air').style.border = "0px solid";
			  document.getElementById('icon_bus').style.border = "0px solid";
			  document.getElementById('icon_rotl').style.border = "0px solid";
			  document.getElementById('icon_rotr').style.border = "0px solid";
			  document.getElementById(iconbtn).style.border = "5px solid #FF6600";
			  }
		  };
		  this.addicon = function(item) {
			  if (item == "cus_routeno") {
				  $scope.cusrouteno += $scope.selectedicon;
			  } else if (item == "cus_dest") {
				  $scope.cusdest += $scope.selectedicon;
			  } else if (item == "cus_extra1") {
				  $scope.cusextra1 += $scope.selectedicon;
			  } else if (item == "cus_extra2") {
				  $scope.cusextra2 += $scope.selectedicon;
			  } else if (item == "cus_extra1r") {
				  $scope.cusextra1r += $scope.selectedicon;
			  } else if (item == "cus_extra2r") {
				  $scope.cusextra2r += $scope.selectedicon;
			  }
			  $scope.selectedicon = "";
			  document.getElementById('icon_bng').style.border = "0px solid";
			  document.getElementById('icon_air').style.border = "0px solid";
			  document.getElementById('icon_bus').style.border = "0px solid";
			  document.getElementById('icon_rotl').style.border = "0px solid";
			  document.getElementById('icon_rotr').style.border = "0px solid";
		  };
		const imgpath = "/settings/BusDispCtrl/image/";
		  this.cusimgfolder = function() {
			bngApi.engineLua('if not FS:directoryExists("' + imgpath + '") then FS:directoryCreate("' + imgpath + '", true) end');
			bngApi.engineLua('Engine.Platform.exploreFolder("' + imgpath + '")');
		  };
		  this.loadimglist = function (index,format) {
			  var imgfilelist = null;
			bngApi.engineLua('FS:findFiles("' + imgpath + '", "*' + format + '", -1, true, false)', (imgfilelist) => {
			if (imgfilelist != null) {
				for (let i = 0; i < imgfilelist.length; i++) {
					imgfilelist[i] = imgfilelist[i].substring(imgpath.length, imgfilelist[i].length - format.length);
				}
				$scope.imglist[index] = imgfilelist;
			}
			});
		  };
		  this.refreshimglist = function (index) {
			  if (index == 1) {
				this.loadimglist(1,$scope.imgformats[$scope.cusrouteimgformat - 1].format)
			  } else if (index == 2) {
				this.loadimglist(2,$scope.imgformats[$scope.cusdestimgformat - 1].format)
			  } else if (index == 3) {
				this.loadimglist(3,$scope.imgformats[$scope.cusextra1imgformat - 1].format)
			  } else if (index == 4) {
				this.loadimglist(4,$scope.imgformats[$scope.cusextra2imgformat - 1].format)
			  }
		  };
	},
    controllerAs: 'ctrl'
  };
}])
